
# Feature Description: This feature file has all APIs related to Health Customer service.

Feature: Verify Health Customer service 
    
    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Verify create customer using POST API
    Given HCS API request
    When I do POST for create customer for HCS
    Then I get 201 created response for HCS
    
    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Verify the same user created twice should give 409 conflict
    Given HCS API request
    When I do same POST for create customer
    Then I get 409 conflict response 

    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Add user data/SetPreference for new customer
    Given HCS API request
    When I add user data for new customer
    Then I get 201 created response for user data

    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Add same user data for same key
    Given HCS API request
    When I add same user data with same key
    Then I get 409 conflict response for same key

    @P1 @US3544 @uiAutoReady @US5913 @regression @HCS
    Scenario: Add user data with lengthy string
    Given HCS API request
    When I add user data with lengthy string
    Then I should get 400 for lengthy string
    
    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Get user data with key
    Given HCS API request
    When I GET user data with userid
    Then I should get 200 response with same userid

    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Get user data with specific key
    Given HCS API request
    When I GET user data with key
    Then I should get response with user data with specific key

    @P1 @US3544 @uiAutoReady @US5913 @smoke @HCS
    Scenario: Add user data using PUT
    Given HCS API request
    When I PUT to Replace newly added value for specific key
    Then I should get response with new data
    

