
# Feature Description: This feature file has all APIs related to Health Results service.

Feature: Verify Health Results service 
    
    @P1 @US2557 @uiAutoReady @US3773 @smoke @HRS
    Scenario: Verify the variant and gene name is returned for /reports when result status is EDGECASE or POSITIVE
    Given HRS API request
    When I do GET request to /reports
    Then I get Variant response
    And connect to DB to get all rows  

    @P1 @uiAutoReady @US7628 @smoke @HRS
    Scenario: Verify GET HRS response with pwn_result_status APPROVED
    Given HRS API request
    When I do GET request to /reports for pwn results status APPROVED
    Then I get HRS response with status as APPROVED
    
    @P1 @uiAutoReady @US7628 @smoke @HRS
    Scenario: Verify GET HRS response with pwn_result_status SESSION_PENDING
    Given HRS API request
    When I do GET request to /reports for pwn results status SESSION PENDING
    Then I get HRS response with status as ON_HOLD

    @P1 @US3330 @uiAutoReady @US3921 @smoke @HRS
    Scenario: Create order by adding reports using POST call
    Given HRS API request
    When I do POST v1 reports
    Then labreport gets created with correct response

    @P1 @US5379 @uiAutoReady @smoke @HRS   
    Scenario: Delete the created report of HRS POST
    Given HRS API request 
    When I do DELETE should delete the existing record with HRS POST
    Then I get success response
    