import { browser, by, element, WebElement} from 'protractor';
import * as globalMethods from 'quest-global';
import {protractor} from 'protractor/built/ptor';

module.exports = {
//gets data from the Test Data Management api
  /**
     * Gets data
     * @param feature
     * @param rtestFile 
     */
    async getData (feature, testFile, apiTest?){
      var config = await browser.getProcessedConfig();
      var configDataUrl = config.dataUrl;
      if(apiTest) configDataUrl += "api";
      else configDataUrl += "ui"

      console.log("Config data url: " + configDataUrl);
      console.log("Entire endpoint: " + configDataUrl + "/" + feature + "/" + testFile);
      var dataFile = await globalMethods.getData(configDataUrl, feature, testFile);
      console.log("Returned datafile:" + dataFile);
      console.log(dataFile);
      return dataFile;
    }
};

