import { by, element, browser, protractor } from 'protractor';
import * as globalMethods from 'quest-global'
let timeout=9500;

const settingsPageText = '/settings';
const copyrightText = 'copyright';
const privacypolicyText = 'privacy';
const termsAndConditionsText = '/terms-conditions';
const languageAssistanceText = 'nondiscrimination';
const assistenciaText = 'nondiscrimination';
const internationalText = 'nondiscrimination';
export class AccountSettings {
  getAccountSettingsTitle() {
    return element(by.id('qd_TakeoverLayout_title'));
  }
  getSecurityAndSignIn() {
    return element(by.id('as_SecurityandSignIn_btn'));
  }
  getChangePassword() {
    return element(by.id('as_ChangePassword_btn'));
  }
  getSecurityQuestionsCard() {
    return element(by.id('as_securityQuestion_card'));
  }
  getPasswordLastUpdated() {
    return element(by.cssContainingText('.ng-star-inserted', 'Last Updated'));
  }
  getContactInformationCard() {
    return element(by.id('as_ContactInformation_card'));
  }
  getInsuranceInformationCard() {
    return element(by.id('as_InsuranceInformation_card'));
  }
  getUserInformation() {
    return element(by.id('as_UserInformation_btn'));
  }
  getPortalSettings() {
    return element(by.id('as_PortalSettings_btn'));
  }
  getNotificationsEmail() {
    return element(by.id('as_NotificationsEmail_btn'));
  }
  getEmailOnNotificationsCard() {
    return element(by.id('mat-expansion-panel-header-5'));
  }
  getPreregistrationRequestTitle() {
    return element(by.id('ns_NotificationCard_email_h0'));
  }
  getPreregistrationRequestToggleSlider() {
    return element(by.id('ns_NotificationCard_email_toggle0'));
  }
  getPreregistrationRequestToggleState() {
    return element(by.id('ns_NotificationCard_email_toggle0-input'));
  }
  getChangesMAdeToYourAccountTitle() {
    return element(by.id('ns_NotificationCard_email_h1'));
  }
  getChangesMadeToYourAccountToggleSlider() {
    return element(by.id('ns_NotificationCard_email_toggle1'));
  }
  getChangesMadeToYourAccountToggleState() {
    return element(by.id('ns_NotificationCard_email_toggle1-input'));
  }
  getToggleAllEmailSettingsSlider() {
    return element(by.id('ns_NotificationGroup_email_toggle'));
  }
  getToggleAllEmailSettingsState() {
    return element(by.id('ns_NotificationGroup_email_toggle-input'));
  }

  getManageMyCircle() {
    return element(by.id('as_YourNetwork_btn'));
  }
  getDemographicInformationEdit() {
    return element(by.id('as_ContactInformation_card')).element(by.buttonText('edit'));
  }
  getContactInformationDetailsCard() {
    return element(by.id('as_ContactInformation_card')).element(by.className('mat-card-content'));
  }
  getInsuranceInformationDetailsCard() {
    return element(by.id('as_InsuranceInformation_card')).element(by.className('mat-card-content'));
  }
  getInsuranceInformationDetailsCardData() {
    return element(by.xpath("//as-info-card[@id='as_InsuranceInformation_card']//..//dl/dd"));
  }
  getInsuranceInformationEdit() {
    return element(by.id('as_InsuranceInformation_card')).element(by.buttonText('edit'));
  }
  getSecurityQuestionsEdit() {
    return element(by.id('as_securityQuestion_card')).element(by.buttonText('edit'));
  }
  getSecurityQuestionsVerify() {
    return element(by.id('as_securityQuestion_card')).element(by.className('mat-card-content'));
  }
  getPrimaryInsuranceCarrier() {
    return element(by.id('as_InsuranceCarrier_txt'));
  }
  getPrimaryInsuranceCarrierErrorMsg() {
    return element(by.xpath("//input[@id='as_InsuranceCarrier_txt']/../../..//mat-error"));
  }
  getPrimaryInsuranceCarrierAsterisk() {
    return element(by.xpath("//label[@aria-owns='as_InsuranceCarrier_txt']//..//span"));
  }
  getInsuranceMemberID() {
    return element(by.id('as_InsuranceMemberId_txt'));
  }
  getInsuranceMemberIDErrorMsg() {
    return element(by.xpath("//input[@id='as_InsuranceMemberId_txt']/../../..//mat-error"));
  }
  getInsuranceMemberIDAsterisk() {
    return element(by.xpath("//label[@aria-owns='as_InsuranceMemberId_txt']//..//span"));
  }
  getInsuranceGroup() {
    return element(by.id('as_InsuranceGroupId_txt'));
  }
  getInsuranceAddress() {
    return element(by.id('as_InsuranceAddress_txt'));
  }
  getInsuranceCity() {
    return element(by.id('as_InsuranceCity_txt'));
  }
  getInsuranceCityErrorMsg() {
    return element(by.xpath("//input[@id='as_InsuranceCity_txt']/../../..//mat-error"));
  }
  getInsuranceState() {
    return element(by.id('as_InsuranceState_txt'));
  }
  getInsuranceZip() {
    return element(by.id('as_InsuranceZip_txt'));
  }
  getInsuranceZipErrorMsg() {
    return element(by.xpath("//input[@id='as_InsuranceZip_txt']/../../..//mat-error"));
  }
  getInsuranceZipAsterisk() {
    return element(by.xpath("//label[@aria-owns='as_InsuranceZip_txt']//..//span"));
  }
  getRelationshipToPatient() {
    return element(by.id('as_RelationshipToPatient_drp'));
  }
  getRelationshipToPatientAsterisk() {
    return element(by.xpath("//label[@aria-owns='as_RelationshipToPatient_drp']//..//span"));
  }
  getGuarantorFirstName() {
    return element(by.id('as_GuarantorFirstName_txt'));
  }
  getGuarantorLastName() {
    return element(by.id('as_GuarantorLastName_txt'));
  }
  getGuarantorMiddleInitial() {
    return element(by.id('as_GuarantorMiddleInitial_txt'));
  }
  getGuarantorDoB() {
    return element(by.id('as_GuarantorDoB_txt'));
  }
  getGuarantorSex() {
    return element(by.id('as_GuarantorSex_txt'));
  }
  getGuarantorPhone() {
    return element(by.id('as_GuarantorPhone_txt'));
  }
  getGuarantorAddress() {
    return element(by.id('as_GuarantorAddress_txt'));
  }
  getGuarantorAddress2() {
    return element(by.id('as_GuarantorAddress2_txt'));
  }
  getGuarantorCity() {
    return element(by.id('as_GuarantorCity_txt'));
  }
  getGuarantorState() {
    return element(by.id('as_GuarantorState_txt'));
  }
  getGuarantorZip() {
    return element(by.id('as_GuarantorZip_txt'));
  }
  getInsuranceSaveChanges() {
    return element(by.id('as_InsuranceSaveChanges_btn'));
  }
  getInsuranceCancel() {
    return element(by.id('as-insurance-form')).element(by.buttonText('Cancel'));
  }
  getSecurityQuestion1() {
    return element(by.id('as_SecurityQuestion1_btn'));
  }

  getSecurityQuestion2() {
    return element(by.id('as_SecurityQuestion2_btn'));
  }
  getSecurityAnswer1() {
    return element(by.id('as_SecurityAnswer1_txt'));
  }
  getSecurityAnswer2() {
    return element(by.id('as_SecurityAnswer2_txt'));
  }
  getSecurityInformationAnswerErrorMsg1() {
    return element(by.xpath("//input[@id='as_SecurityAnswer1_txt']/../../..//mat-error"));
  }
  getSecurityInformationAnswerErrorMsg2() {
    return element(by.xpath("//input[@id='as_SecurityAnswer2_txt']/../../..//mat-error"));
  }
  getSaveChangesSecurityQuestions() {
    return element(by.id('as_SecurityQuestionSaveChanges_btn'));
  }
  getCancelSecurityQuestions() {
    return element(by.id('as-security-questions-form')).element(by.buttonText('Cancel'));
  }
  getCloseButton() {
    return element(by.xpath("//mat-icon[contains(text(),'close')]"));
  }
  backButton() {
    return element(by.id('gl_Back_btn'));
  }
  toggleMasterNotificationEmails() {
    return element(by.id('ns_NotificationGroup_email_toggle'));
  }
  toggleNotificationEmails() {
    return element(by.id('ns_NotificationCard_email_toggle0'));
  }
  toggleNotificationEmails2() {
    return element(by.id('ns_NotificationCard_email_toggle1'));
  }

  getDemogrpahicInformationContactSecondaryNumber() {
    return element(by.id('as_ContactSecondaryPhone_txt'));
  }
  getDemogrpahicInformationContactAddress2() {
    return element(by.id('as_ContactAddress2_txt'));
  }
 
  getDemographicInformationFirstName() {
    return element(by.id('as_ContactFirstName_txt'));
  }
  getDemographicInformationLastName() {
    return element(by.id('as_ContactLastName_txt'));
  }
  getDemographicInformationMiddleInitial() {
    return element(by.id('as_ContactMiddleInitial_txt'));
  }
  getDemographicInformationDoB() {
    return element(by.id('as_ContactDateOfBirth_date'));
  }
  getDemographicInformationSex() {
    return element(by.id('as_ContactSex_drp'));
  }
  getDemographicInformationFemale(){
    return globalMethods.getElementByXpath("//span[@class='mat-option-text'][contains(text(),'Female')]");
  }
  getDemographicInformationMale(){
    return globalMethods.getElementByXpath("//span[@class='mat-option-text'][contains(text(),'Male')]");
  }
  getDemographicInformationPrimaryPhoneNumber() {
    return element(by.id('as_ContactPrimaryPhone_txt'));
  }
  getDemographicInformationEmail() {
    return element(by.id('as_ContactEmail_txt'));
  }
  getDemographicInformationAddress() {
    return element(by.id('as_ContactAddress_txt'));
  }
  getDemographicInformationZip() {
    return element(by.id('as_ContactZip_txt'));
  }
  getDemographicInformationCity() {
    return element(by.id('as_ContactCity_txt'));
  }
  getDemographicInformationState() {
    return element(by.id('as_State_txt'));
  }
  getDemographicInfoSaveChanges() {
    return element(by.id('as_ContactSaveChanges_btn'));
  }
  getDemographicInformationDetailsCard() {
    return element(by.id('as_ContactInformation_card')).element(by.className('mat-card-content'));
  }
  getChangePasswordLink() {
    return element(by.xpath("//div[@id='as_ChangePassword_btn']//a"));
  }
  cancelContactChanges() {
    return element(by.id('as_ContactCancelChanges_btn'));
  }
  clickLegalNotice() {
    return element(by.id('as_LegalNotices_btn'));
  }
  getLegalNoticeHeaderCard() {
    return element(by.xpath("//span[@id='as_LegalNotices_btn']/../../.."));
  }
  getCopyright() {
    return element(by.id('as_copyright_btn'));
  }
  getPrivacyPolicy() {
    return element(by.id('as_privacy-policy_btn'));
  }
  getTermsAndConditions() {
    return element(by.id('as_terms-and-conditions_btn'));
  }
  getLanguageAssistance() {
    return element(by.id('as_language-assistance-non-discrimination-notice_btn'));
  }
  getNondiscrimination() {
    return element(by.id('as_asistencia-de-idiomas-aviso-de-no-discriminaci-n_btn'));
  }
  getInternational() {
    return element(by.id('as_-_btn'));
  }
  getLegalNoticeCardNewPageValidator(){
    return element(by.id('logo-qd'));
  }
  getElectronicAuthorization() {
    return element(by.id('as_electronicAuth_btn'));
  }
  validatePatientAuthTxt() {
    return element(by.id('as_HipaaTerms1_text'));
  }
  ValidateNoticeToPatient() {
    return element(by.id('as_HipaaTerms2_text'));
  }
  getNoInsuranceInformation() {
    return globalMethods.getElementByXpath("//as-info-card[@id='as_InsuranceInformation_card']//qd-loading-container/div");
  }
  
  clickAcceptTermsChk() {
    // below element is not clickable
    // return element(by.id('as_Hipaa_chk'));
    return element(by.xpath("//mat-checkbox[@id='as_Hipaa_chk']//div[@class='mat-checkbox-inner-container']"));
  }
  clickAuthorizeTermsBtn() {
    return element(by.id('as_HipaaAuthorize_btn'));
  }
  clickCancelAuthorizeTermsBtn() {
    return element(by.id('as_HipaaCancel_btn'));
  }

  electronicRemoveAuth() {
    return element(by.id('as_electronicAuthRemove_btn'));
  }
  validateElectronicAuthBox() {
    return element(by.id('as_electronicauth_txt'));
  }
  revokeConfirmation() {
    return element(by.id('rs_DeleteLab_Button'));
  }
  selectCancelRemoveConfirmation() {
    return element(by.id('rs_CancelLabDelete_Button'));
  }
  selectContinueFlowSuccessBtn() {
    return element(by.id('as_HipaaSuccessContinue_Button'));
  }
  selectDismissFlowSuccessBtn() {
    return element(by.id('as_HipaaSuccessDismiss_Button'));
  }
  selectNotificationsIcon() {
    return element(by.id('notifications'));
  }
  selectNotificationVerifyBtn() {
    return element(by.cssContainingText('.mat-button-wrapper', 'Verify'));
  }
  kbaSsnField() {
    return element(by.id('as_kbaSsn_txt'));
  }
  kbaContinueBtn() {
    return element(by.id('as_KbaContinue_btn'));
  }
  kbaQuestionsContinueBtn() {
    return element(by.id('kba_KbaQuestionsContinue_btn'));
  }
  kbaQuestionsCancelBtn() {
    return element(by.id('kba_KbaQuestionsCancel_btn'));
  }
  kbaQuestionsTimer() {
    return element(by.id('kba_Timer_txt'));
  }
  getDemographicValue() {
    return element(by.xpath("//as-info-card[@id='as_ContactInformation_card']//../dl/dd"));
  }
  getCarrier(){
    return element(by.xpath("//dt[contains(text(),'Carrier')]"));
  }
  getMemberID(){
    return element(by.xpath("//dt[contains(text(),'MemberID')]"));
  }
  getGroup(){
    return element(by.xpath("//dt[contains(text(),'Group')]"));
  }
  getAddress(){
    return element(by.xpath("//as-info-card[@id='as_InsuranceInformation_card']//mat-card-content//dt[contains(text(),'Address')]"));
  }
  getEmail(){
    return element(by.xpath("//dt[contains(text(),'Email')]"));
  }
  getDOB(){
    return element(by.xpath("//dt[contains(text(),'DOB')]"));
  }
  getSex(){
    return element(by.xpath("//dt[contains(text(),'Sex')]"))
  }
  getPrimaryPhone() {
    return element (by.xpath("//dt[contains(text(),'Primary Phone')]"));
  }
  getAddressOnDemographicInformationCard(){
    return element(by.xpath("//as-info-card[@id='as_ContactInformation_card']//dt[contains(text(),'Address')]"));
  }
  getLearnMore(){
    return element(by.xpath("//a[@class='account-settings__direct-email-link']"));
  }
  getCreateDirectAddressModalTitle(){
    return element(by.xpath("//h2[@class='direct-address-form__title']"));
  }
  getCreateDirectAddressModalSubheaderText(){
    return element(by.xpath("//div[@class='direct-address-form__container']//..//p"));
  }
  getMessageInBar(){
    return element(by.xpath("//span[@class='direct-address-form__input-suffix']"));
  }
  getCreateDirectEmailAddress(){
    return element(by.xpath("//button[@class='mat-raised-button mat-primary']"));
  }
  getCancel(){
    return element(by.xpath("//button[@class='mat-button mat-primary']"));
  }
  getCreateDirectAddressCard(){
    return element(by.xpath("//div[@class='account-settings__direct-email']/mat-card"));
  }
  getMessageOnreateDirectAddressCard(){
    return element(by.xpath("//div[@class='ng-star-inserted']/span"));
  }
  getDirectEmailAddress(){
    return element(by.xpath("//div[@class='account-settings__direct-email-address ng-star-inserted']"));
  }
  getManageDeviceAuthorizations(){
    return element(by.xpath("//a[@id='as_NotificationsEmail_btn'][@routerlink='/settings/devices']"));
  } 
  getPrimaryInsuranceSection(){
    return element(by.xpath("//form[@id='as-insurance-form']/h4[1]"));
  }
  getPrimaryInsuranceHolderSection(){
    return element(by.xpath("//form[@id='as-insurance-form']/h4[1]"));
  } 
  getDevice(){
    return element(by.xpath("//main[@class='devices-settings']//ul//li[1]"));
  } 
  getRemoveDevice(){
    //return element(by.xpath("//button[@class='devices-settings__remove mat-button mat-primary']"));
    // Changed the locator bcos, the above locator fails the script atleast once when i execute for 5 times.
    return globalMethods.getElementByXpath("//span[contains(text(),'Remove Device')]");
  }
  getClose(){
    return element(by.id('gl_CloseButton_Btn'));
  }
  getRemoveDeviceCancel(){
    return element(by.id('rs_CancelLabDelete_Button'));
  }
  getRemoveDevicePopUpTitle(){
    return element(by.id('rs_DeleteConfirmation_title'));
  }
  getRemove(){
    return element(by.id('rs_DeleteLab_Button'));
  }
  getContactFormInfo(){
    return globalMethods.getElementByXpath("//p[@class='as-contact-form__info']");
  }
  getCOPPAActError(){
    return globalMethods.getElementByXpath("//input[@id='as_ContactDateOfBirth_date']/../../..//mat-error");
  }

  // Setters
  /**
   * clickNotificationsEmail method clicks on Notifications Email section of Account Settings page.
   */
  async clickNotificationsEmail(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getNotificationsEmail(), 'Notifications Email', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickEditInsurance method clicks on Edit icon of Insurance Information Card
   */
  async clickEditInsurance(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getInsuranceInformationEdit(), 'Insurance Information Edit', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickInsuranceInfoSaveChanges method clicks on 'Save Changes' button of Insurance Information card.
   */
  async clickInsuranceInfoSaveChanges(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getInsuranceSaveChanges(), 'Insurance Save Changes', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickInsuranceInfoCancel method clicks on 'Cancel' button of Insurance Information card.
   */
  async clickInsuranceInfoCancel(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getInsuranceCancel(), 'Insurance Cancel', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickEditSecurityQuestions(): Promise<void> {
    await globalMethods.click(await this.getSecurityQuestionsEdit(), 'Security Questions Edit', timeout);
  }
  async clickSaveSecurityQuestions(): Promise<void> {
    await globalMethods.click(await this.getSaveChangesSecurityQuestions(), 'Save Changes Security Questions', timeout);
  }
  async clickCancelSecurityQuestions(): Promise<void> {
    await globalMethods.click(await this.getCancelSecurityQuestions(), 'Cancel Security Questions', timeout);
  }
  /**
   * clickEditDemographicInformation method clicks on Edit icon of Demographic Information card of Account Settings page.
   * This method works for desktop and mobile view port.
   */
  async clickEditDemographicInformation(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getDemographicInformationEdit(), true, timeout);
    await globalMethods.waitForClickable(await this.getDemographicInformationEdit(), timeout);
    // Sowjanya 8/8: Changing this to java script click because sometimes it is not able to click on Edit.
    await browser.executeScript('arguments[0].click();', await this.getDemographicInformationEdit());
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickDemographicInfoSaveChanges method clicks on Save Changes button of Demographic Information Card.
   * This method works for desktop and mobile view port.
   */
  async clickDemographicInfoSaveChanges(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getDemographicInfoSaveChanges(),true,timeout);
    await globalMethods.waitForClickable(await this.getDemographicInfoSaveChanges(), timeout);      
    await globalMethods.click(await this.getDemographicInfoSaveChanges(), 'Demographic Info Save Changes', timeout);
    //Adding sleep here because sometimes the process takes time to move to next step.
    await browser.sleep(15000);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickDemographicInfoCancel method clicks on Cancel button of Demographic Information Card.
   * This method works for desktop and mobile view port.
   */
  async clickDemographicInfoCancel(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.cancelContactChanges(), 'cancel Contact Changes', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickChangePasswordLink method clicks on Change Password link.
   */
  async clickChangePasswordLink(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.click(await this.getChangePasswordLink(), 'Change Password Link', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickEmailOnNotificationsCard():Promise<void>{
    await globalMethods.click(await this.getEmailOnNotificationsCard(), 'Email On Notifications', timeout);
  }
  async clickPreregistrationRequestToggleSlider():Promise<void>{
    await globalMethods.click(await this.getPreregistrationRequestToggleSlider(), 'Preregistration Request Toggle Slider', timeout);
  }
  async clickChangesMadeToYourAccountToggleSlider():Promise<void>{
    await globalMethods.click(await this.getChangesMadeToYourAccountToggleSlider(), 'Changes Made To Your Account Toggle Slider', timeout);
  }
  async clickToggleAllEmailSettingsSlider():Promise<void>{
    await globalMethods.click(await this.getToggleAllEmailSettingsSlider(), 'Toggle All Email Settings Slider', timeout);
  }
  /**
   * clickLearnMore method clicks on 'Learn More' link of Direct Messaging section in Account Settings page
   */
  async clickLearnMore():Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getLearnMore(), true, timeout);
    await globalMethods.click(await this.getLearnMore(), 'Learn More', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickCancel method clicks on Cancel button on Create Direct Address Modal
   */
  async clickCancel():Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getCancel(), true, timeout);
    await globalMethods.click(await this.getCancel(), 'Cancel', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickManageDeviceAuthorizations method clicks on 'Manage Device Authorization' of Account Settings Page.
   */
  async clickManageDeviceAuthorizations():Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getManageDeviceAuthorizations(), true, timeout);
    await globalMethods.click(await this.getManageDeviceAuthorizations(), 'Manage Device Authorizations', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickRemoveDevice method clicks on 'Remove Device' button of Manage Device Authorizations Page.
   */
  async clickRemoveDevice():Promise<void>{
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRemoveDevice(), true, timeout);
    await globalMethods.click(await this.getRemoveDevice(), 'Remove Device', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickElectronicAuthorization method clicks on Authorize button of Account Settings page.
   */
  async clickElectronicAuthorization():Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getElectronicAuthorization(), true, timeout);
    await globalMethods.verifyElement(await this.getElectronicAuthorization(), timeout, true);
    await globalMethods.click(await this.getElectronicAuthorization(), 'Electronic Authorization on Account Settings page', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickClose method clicks on close button of Account Settings page.
   */
  async clickClose(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getClose(), true, timeout);
    await globalMethods.waitForClickable(await this.getClose(), timeout);
    //await browser.executeScript('arguments[0].click();', await this.getClose());
    await globalMethods.click(await this.getClose(), 'Close Button', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickRevoke method clicks on Revoke button on Account Settings page.
   */
  async clickRevoke(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.electronicRemoveAuth(), true, timeout);
    await globalMethods.waitForClickable(await this.electronicRemoveAuth(), timeout);
    await globalMethods.click(await this.electronicRemoveAuth(), 'Revoke Button on Account Settings Page', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickCancelRevokeConfirmation method clicks on Cancel button of Revoke Confirmation Popup.
   */
  async clickCancelRevokeConfirmation(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.selectCancelRemoveConfirmation(), true, timeout);
    await globalMethods.waitForVisible(await this.selectCancelRemoveConfirmation(), timeout);    
    await globalMethods.click(await this.selectCancelRemoveConfirmation(), 'Cancel Button on Revoke Confirmation Popup', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickPortalSettings(): Promise<void> {
    await globalMethods.click(await this.getPortalSettings(), 'Portal Settings on Account Settings Page', timeout);
  }
  /**
   * clickManageMyCircle methods clicks on 'Manage My Circle' on Account Settings page.
   */
  async clickManageMyCircle(): Promise<void> {
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getManageMyCircle(), true, timeout);
    await globalMethods.click(await this.getManageMyCircle(), 'Manage My Circle on Account Settings Page', timeout);
    await browser.waitForAngularEnabled(true);
  }
  async clickBack(): Promise<void> {
    await globalMethods.click(await this.backButton(), 'Back', timeout);
  }
  async procedureUpdateDemographicInformation(firstName, lastName){
    await globalMethods.clearText(await this.getDemographicInformationFirstName(), "Demographic Card First Name", timeout);
    await this.getDemographicInformationFirstName().sendKeys(firstName);
    await globalMethods.clearText(await this.getDemographicInformationLastName(), "Demographic Card Last Name", timeout);
    await this.getDemographicInformationLastName().sendKeys(lastName);
  }
  /**
   * procedureEditDemographicsData method clears text and enters firstname and last name details of Demographic Information card.
   * This method works for desktop and mobile view port.
   * @param dataFile 
   */
  async procedureEditDemographicsData(dataFile){
    var FirstName = await dataFile.FirstName;
    var LastName = await dataFile.LastName;
    await browser.waitForAngularEnabled(false);
    if(FirstName != ""){
        await globalMethods.clearText(await this.getDemographicInformationFirstName(), 'clearing first name', timeout);
        await globalMethods.sendText(await this.getDemographicInformationFirstName(), dataFile.FirstName, timeout);
    }
    if(LastName != ""){
        await globalMethods.clearText(await this.getDemographicInformationLastName(), 'clearing last name', timeout);
        await globalMethods.sendText(await this.getDemographicInformationLastName(), dataFile.LastName, timeout);
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyDisplayOfAccountSettings method verifies for an element 'Account Settings Title' available on Account Settings page.
   */
  async verifyDisplayOfAccountSettings(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getAccountSettingsTitle(), true, timeout);
    await globalMethods.verifyElement(await this.getAccountSettingsTitle(), timeout, true);
    var currentUrl = await browser.getCurrentUrl();
    await globalMethods.verifyTextContains(currentUrl, settingsPageText, true);
    await globalMethods.log("In Account Settings Page");
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyRevoke method verifies for the display of Revoke button on Account Settings page.
   */
  async verifyRevoke(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("Verifying the display of Revoke button on Account Settings Page");
    await globalMethods.waitForElement(await this.electronicRemoveAuth(), true, timeout);
    await globalMethods.waitForClickable(await this.electronicRemoveAuth(), timeout);
    await globalMethods.verifyElement(await this.electronicRemoveAuth(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }  
  /**
   * procedureEnterDataInInsuranceInfo method gets test data and sends text to the fields in Insurance Information section.
   * @param dataFile holds test data
   */
  async procedureEnterDataInInsuranceInfo(dataFile){
    var carrier = dataFile.InsuranceInfo.carrier;
    var memberID = dataFile.InsuranceInfo.memberID;
    var group = dataFile.InsuranceInfo.group;
    var address = dataFile.InsuranceInfo.Address;
    var zip = dataFile.InsuranceInfo.zip;
    var city = dataFile.InsuranceInfo.city;
    await browser.waitForAngularEnabled(false);
    if(carrier != ""){
        await globalMethods.sendText(await this.getPrimaryInsuranceCarrier(), dataFile.InsuranceInfo.carrier, timeout);
    }
    if(memberID != ""){
        await globalMethods.sendText(await this.getInsuranceMemberID(), dataFile.InsuranceInfo.memberID, timeout);
    }
    if(group != ""){
        await globalMethods.sendText(await this.getInsuranceGroup(), dataFile.InsuranceInfo.group, timeout);
    }
    // 7/31: Sowjanya - Commented the state and city code because these two fields gets filled automatically after entering valid zip code.
    // if(state != ""){
    //     await globalMethods.selectFromDropDown(await accountSettings.getInsuranceState(), dataFile.InsuranceInfo.state, timeout);
    // }
    if(zip != ""){
        await globalMethods.sendText(await this.getInsuranceZip(), dataFile.InsuranceInfo.zip, timeout);
    }
    if(city != ""){
        await globalMethods.sendText(await this.getInsuranceCity(), dataFile.InsuranceInfo.city, timeout);
    }
    if(address != ""){
        await globalMethods.sendText(await this.getInsuranceAddress(), dataFile.InsuranceInfo.Address, timeout);
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureSelectRelationship method enters data for all fields of Insurance Information section.
   * @param dataFile 
   */
  async procedureSelectRelationship(dataFile){
    await browser.waitForAngularEnabled(false);
    await globalMethods.selectFromDropDown(await this.getRelationshipToPatient(), dataFile.InsuranceInfo.relationshipToPatient, timeout);
    if (dataFile.InsuranceInfo.relationshipToPatient !== "Self") {
        await globalMethods.log("Not a self relationship");
        await globalMethods.sendText(await this.getGuarantorFirstName(), dataFile.InsuranceInfo.firstName, timeout);
        await globalMethods.sendText(await this.getGuarantorLastName(), dataFile.InsuranceInfo.lastName, timeout);
        await globalMethods.sendText(await this.getGuarantorMiddleInitial(), dataFile.InsuranceInfo.middleName, timeout);
        await globalMethods.sendText(await this.getGuarantorDoB(), dataFile.InsuranceInfo.Dob, timeout);
        await globalMethods.selectFromDropDown(await this.getGuarantorSex(), dataFile.InsuranceInfo.guarantorSex, timeout);
        await globalMethods.sendText(await this.getGuarantorPhone(), dataFile.InsuranceInfo.Phone, timeout);
        await globalMethods.sendText(await this.getGuarantorAddress(), dataFile.InsuranceInfo.dependentAddress, timeout);
        await globalMethods.sendText(await this.getGuarantorAddress2(), dataFile.InsuranceInfo.dependentAddress2, timeout);
        await globalMethods.sendText(await this.getGuarantorCity(), dataFile.InsuranceInfo.dependentCity, timeout);
        await globalMethods.selectFromDropDown(await this.getGuarantorState(), dataFile.InsuranceInfo.dependentState, timeout);
        await globalMethods.sendText(await this.getGuarantorZip(), dataFile.InsuranceInfo.dependentZip, timeout);

    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyInsuranceInformation method verifies the insurance information details.
   * @param dataFile holds test data containing details of Insurance Information card.
   */
  async procedureVerifyInsuranceInformation(dataFile){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getInsuranceInformationDetailsCard(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceInformationDetailsCard(), timeout, true);
    var insuranceInfoDetails = await this.getInsuranceInformationDetailsCard().getText();
    await globalMethods.log("Insurance Info details : ");
    await globalMethods.log(insuranceInfoDetails);
    await globalMethods.log("Insurance Info details from dataFile: ");
    let detailsArr: Array<string> = [dataFile.InsuranceInfo.carrier, dataFile.InsuranceInfo.memberID, dataFile.InsuranceInfo.group,
        dataFile.InsuranceInfo.verifyAddress];
    for(let i in detailsArr) {
      await globalMethods.log("========" + detailsArr[i] + "=============");
        await globalMethods.textContains(insuranceInfoDetails, detailsArr[i]);
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyErrorMsgOnInsuranceInfoCard method verifies the error messages for Zip, City, Carrier, MemberId fields.
   */
  async procedureVerifyErrorMsgOnInsuranceInfoCard(){
    const Carrier_MemeberID_ErrorMsg = "The minimum length for this field is 3";
     //const zip_ErrorMsg = "The zipcode does not belong to selected state";
     const zip_ErrorMsg = "Valid zip code format is 55555 or 55555-4444";
     const city_ErrorMsg = "Valid characters are letters, and symbols: -./";
     await browser.waitForAngularEnabled(false);
     var actualPrimaryCarrierErrorMsg = await this.getPrimaryInsuranceCarrierErrorMsg().getText();
     await globalMethods.log(actualPrimaryCarrierErrorMsg.trim());
     await globalMethods.verifyText(actualPrimaryCarrierErrorMsg.trim(), Carrier_MemeberID_ErrorMsg, true);
 
     var actualMemberIdErrorMsg = await this.getInsuranceMemberIDErrorMsg().getText();
     await globalMethods.log(actualMemberIdErrorMsg.trim());
     await globalMethods.verifyText(actualMemberIdErrorMsg.trim(), Carrier_MemeberID_ErrorMsg, true);
 
     var actualZipErrorMsg = await this.getInsuranceZipErrorMsg().getText();
     await globalMethods.log("Actual Error Message: "+actualZipErrorMsg.trim());
     await globalMethods.verifyText(actualZipErrorMsg.trim(), zip_ErrorMsg, true);
     
     var actualCityErrorMsg = await this.getInsuranceCityErrorMsg().getText();
     await globalMethods.log(actualCityErrorMsg.trim());
     await globalMethods.verifyText(actualCityErrorMsg.trim(), city_ErrorMsg, true);
     await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyPrimaryInsuranceSection method verifies the primary insurance section of Account Settings page.
   */
  async procedureVerifyPrimaryInsuranceSection(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getPrimaryInsuranceSection(), true, timeout);
    await globalMethods.verifyElement(await this.getPrimaryInsuranceSection(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyPrimaryInsuranceSectionElements method verifies the elements in primary insurance section.
   */
  async procedureVerifyPrimaryInsuranceSectionElements(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getPrimaryInsuranceCarrier(), true, timeout);
    await globalMethods.verifyElement(await this.getPrimaryInsuranceCarrier(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceMemberID(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceMemberID(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceGroup(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceGroup(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceAddress(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceAddress(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceCity(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceCity(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceState(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceState(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceZip(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceZip(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyAsteriskOnMandatoryFieldsOfPrimaryInsuranceHolderSection method verifies for the 'Asterisk' symbol for the mandatory fields of Primary Insurance Holder Section.
   */
  async verifyAsteriskOnMandatoryFieldsOfPrimaryInsuranceHolderSection(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getPrimaryInsuranceCarrierAsterisk(), true, timeout);
    await globalMethods.verifyElement(await this.getPrimaryInsuranceCarrierAsterisk(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceMemberIDAsterisk(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceMemberIDAsterisk(), timeout, true);
    await globalMethods.waitForElement(await this.getInsuranceZipAsterisk(), true, timeout);
    await globalMethods.verifyElement(await this.getInsuranceZipAsterisk(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyAsteriskOnMandatoryFieldsOnPrimaryInsuranceHolderSection method verifies 'Asterisk' mark for 'Relationship To Patient' field.
   */
  async verifyAsteriskOnMandatoryFieldsOnPrimaryInsuranceHolderSection(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRelationshipToPatientAsterisk(), true, timeout);
    await globalMethods.verifyElement(await this.getRelationshipToPatientAsterisk(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureClickEmailOnNotificationsPage methods clicks Email option of Notifications card.
   * @param dataFile holds test data 
   */
  async procedureClickEmailOnNotificationsPage(dataFile){
    var dataFileProperty = await dataFile.isExpandable;
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("property=>" + dataFileProperty);
    if (!dataFileProperty) {
        await this.clickEmailOnNotificationsCard();
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyNoInsuranceInfoMsg method verifies 'No Insurance Information" message on Insurance Information Card.
   */
  async procedureVerifyNoInsuranceInfoMsg(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.log("Verifying No Insurance Information Message");
    await globalMethods.waitForElement(await this.getNoInsuranceInformation(), true, timeout);
    await globalMethods.verifyElement(await this.getNoInsuranceInformation(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyInsuranceInfoElements methos verifies elements of insurance information card.
   * @param dataFile holds test data
   */
  async procedureVerifyInsuranceInfoElements(dataFile){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getInsuranceInformationDetailsCardData(), true, timeout);
    var InsuranceInfoDetails = await this.getInsuranceInformationDetailsCard().getText().then(async function(text){
        return await text.toString().trim().toUpperCase();
    });
    await globalMethods.log("Insurance Information details : ");
    await globalMethods.log(InsuranceInfoDetails);
    await globalMethods.log("Insurance Information details from dataFile: ");
    let detailsArr: Array<string> = [dataFile.carrier, dataFile.memberID, dataFile.Group, dataFile.verifyAddress];
    for(let i in detailsArr) {
        await globalMethods.log("========" + detailsArr[i] + "=============");
        await globalMethods.verifyTextContains(InsuranceInfoDetails, detailsArr[i], true);
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyAbsenceOfOptionsOnPortalSettingsNotificationsPage method verifies the absence of options on portal settings notifications page.
   */
  async procedureVerifyAbsenceOfOptionsOnPortalSettingsNotificationsPage(){  
    await browser.waitForAngularEnabled(false);
    var elementPresence = await globalMethods.waitForElement(await this.getPreregistrationRequestTitle(), false, timeout);
    await globalMethods.verifyFailOnError(elementPresence, false, "Now options are collapsed",true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyPresenceOfOptionsOnPortalSettingsNotificationsPage method verifies for presence of options on portal settings notifications page.
   */
  async procedureVerifyPresenceOfOptionsOnPortalSettingsNotificationsPage(){  
    await browser.waitForAngularEnabled(false);
    var elementPresence = await globalMethods.waitForElement(await this.getPreregistrationRequestTitle(), true, timeout);
    await globalMethods.verifyFailOnError(elementPresence, true, "Now options are visible",true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureClickPreRegistrationRequest method clicks on Preregistration request toggle slider to enable or disable preregistration.
   * @param preregToggle 
   */
  async procedureClickPreRegistrationRequest(preregToggle){
    //var preregToggle = await dataFile.preRegIsEnabled;
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getChangesMadeToYourAccountToggleState(),true,timeout);
    await globalMethods.waitForVisible(await this.getChangesMadeToYourAccountToggleState(), timeout);
    var isSelectedToggle = await this.getPreregistrationRequestToggleState().isSelected();
    if (isSelectedToggle && !preregToggle) {
        await this.clickPreregistrationRequestToggleSlider().then(function () {
            globalMethods.log('Preregistration is now disabled');
        });
    } else {
        await this.clickPreregistrationRequestToggleSlider().then(function () {
            console.log('Preregistration is now enabled');
        });
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyPreRegRequestStatus method verifies for toggle status of preregistration request.
   * @param preregToggle 
   */
  async verifyPreRegRequestStatus(preregToggle){
    await browser.waitForAngularEnabled(false);
    var expectedValue = await this.getPreregistrationRequestToggleState().isSelected();
    //var actualValue = await dataFile.preRegIsEnabled;
    var actualValue = preregToggle;
    await globalMethods.log(expectedValue + "=" + actualValue);
    await globalMethods.verifyFailOnError(actualValue, expectedValue,"Pre registration Request Toggle State", true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureClickChangesMadeToYourAccountToggle method verifies for toggle status of 'Changes Made To Your Account' field.
   * @param changesMadeToYourAccountToggle 
   */
  async procedureClickChangesMadeToYourAccountToggle(changesMadeToYourAccountToggle){   
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getChangesMadeToYourAccountToggleState(),true,timeout);
    var isSelectedToggle = await this.getChangesMadeToYourAccountToggleState().isSelected();
    console.log("isSelectedToggle=>" + isSelectedToggle);
    if (isSelectedToggle && !changesMadeToYourAccountToggle) {
        await this.clickChangesMadeToYourAccountToggleSlider().then(function () {
            console.log('Changes made to your account are now disabled');
        });
    } else {
        await this.clickChangesMadeToYourAccountToggleSlider().then(function () {
            console.log('Changes made to your account are now enabled');
        });
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyChangesMadeToYourAccountStatus method verifies for toggle status of 'Changes Made To Your Account' field.
   * @param changesMadeToYourAccountIsEnabled 
   */
  async verifyChangesMadeToYourAccountStatus(changesMadeToYourAccountIsEnabled){
    await browser.waitForAngularEnabled(false);
    var expectedValue = await this.getChangesMadeToYourAccountToggleState().isSelected();
    //var actualValue = await dataFile.changesMadeToYourAccountIsEnabled;
    var actualValue = changesMadeToYourAccountIsEnabled;
    console.log(expectedValue + "=" + actualValue);
    await globalMethods.verifyFailOnError(actualValue, expectedValue,"Changes Made To Your Account Toggle State", true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyToggleOnPortalSettingsNotifications method verifies for the presence of toggle on portal settings notifications card.
   */
  async verifyToggleOnPortalSettingsNotifications(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getManageMyCircle(), true, timeout);
    await globalMethods.verifyElement(await this.getManageMyCircle(), timeout, true);
    await globalMethods.waitForElement(await this.getManageDeviceAuthorizations(), true, timeout);
    await globalMethods.verifyElement(await this.getManageDeviceAuthorizations(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * EnterDemographicData method enters demographic data into the fields of demographic information card.
   * @param dataFile 
   */
  async EnterDemographicData(dataFile){    
    var FirstName = await dataFile.DemographicInfo.FirstName;
    var LastName = await dataFile.DemographicInfo.LastName;
    var MiddleInitial = await dataFile.DemographicInfo.MiddleInitial;
    var DateOfBirth = await dataFile.DemographicInfo.DateOfBirth;
    var Sex = await dataFile.DemographicInfo.Sex;
    var PrimaryPhoneNumber = await dataFile.DemographicInfo.PrimaryPhoneNumber;
    var Email = await dataFile.DemographicInfo.Email;
    var Address = await dataFile.DemographicInfo.Address;
    var Zip = await dataFile.DemographicInfo.zip;
    var City = await dataFile.DemographicInfo.city;
    //var State = await dataFile.DemographicInfo.state;
    await browser.waitForAngularEnabled(false);
    if(FirstName != ""){
        await globalMethods.sendText(await this.getDemographicInformationFirstName(), dataFile.DemographicInfo.FirstName, timeout);
    }
    if(LastName != ""){
        await globalMethods.sendText(await this.getDemographicInformationLastName(), dataFile.DemographicInfo.LastName, timeout);
    }
    if(MiddleInitial != ""){
        await globalMethods.sendText(await this.getDemographicInformationMiddleInitial(), dataFile.DemographicInfo.MiddleInitial, timeout);
    }
    if(DateOfBirth != ""){
        // Used sendKeys(protractor.Key.TAB) and sendKeys(protractor.Key.DELETE); instead of clear() because clear() will unable to wipe out date field
        await this.getDemographicInformationMiddleInitial().sendKeys(protractor.Key.TAB);
        await this.getDemographicInformationDoB().sendKeys(protractor.Key.DELETE);
        await globalMethods.sendText(await this.getDemographicInformationDoB(), dataFile.DemographicInfo.DateOfBirth, timeout);
    }
     if(Sex != ""){
    
    //await globalMethods.selectFromDropDown(await this.getDemographicInformationSex(), dataFile.DemographicInfo.Sex, timeout);
    await this.getDemographicInformationSex().click();
    // Adding hard wait here, it takes sometime to load the element.
    await browser.sleep(2000);    
    var sex = dataFile.DemographicInfo.Sex;
    switch(sex){
      case 'Female':
          await this.getDemographicInformationFemale().click();
          break;
      case 'Male':
        await this.getDemographicInformationMale().click();
      default:
        await this.getDemographicInformationFemale().click();
        break
    }    
     }
    if(PrimaryPhoneNumber != ""){
        await globalMethods.sendText(await this.getDemographicInformationPrimaryPhoneNumber(), dataFile.DemographicInfo.PrimaryPhoneNumber, timeout);
    }
    if(Email != ""){
        await globalMethods.sendText(await this.getDemographicInformationEmail(), dataFile.DemographicInfo.Email, timeout);
    }
    if(Address != ""){
        await globalMethods.sendText(await this.getDemographicInformationAddress(), dataFile.DemographicInfo.Address, timeout);
    }
    if(Zip != ""){
        await globalMethods.sendText(await this.getDemographicInformationZip(), dataFile.DemographicInfo.zip, timeout);
    }
    if(City != ""){
        await globalMethods.clearText(await this.getDemographicInformationCity(), "Demographic City", timeout)
        await globalMethods.sendText(await this.getDemographicInformationCity(), dataFile.DemographicInfo.city, timeout);
    }
    // 7/31: Sowjanya - Commenting the below line because there is a change in UI functionality. As soon as you enter valid zip code, it will automatically populate the other fields.
    // if(State != ""){
    //     await globalMethods.selectFromDropDown(await accountSettings.getDemographicInformationState(), dataFile.DemographicInfo.state, timeout);
    // }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyDemographicDetails method verifies demographic details displayed in demographic card.
   * @param dataFile 
   */
  async verifyDemographicDetails(dataFile){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getDemographicValue(), true,timeout);
    //var DemographicInfoDetails = await accountSettings.getContactInformationDetailsCard().getText();
    var DemographicInfoDetails = await this.getContactInformationDetailsCard().getText().then(async function(text){
        return await text.toString().trim().toLowerCase();
    });
    await globalMethods.log("Demographic Info details : ");
    await globalMethods.log(DemographicInfoDetails);
    await globalMethods.log("Demographic Info details from dataFile: ");
    let detailsArr: Array<string> = [dataFile.DemographicInfo.Email, dataFile.DemographicInfo.DateOfBirth, dataFile.DemographicInfo.Sex, dataFile.DemographicInfo.verifyPrimaryPhoneNumber, dataFile.DemographicInfo.verifyAddress];
    for(let i in detailsArr) {
        await globalMethods.log("========" + detailsArr[i] + "=============");
        await globalMethods.textContains(DemographicInfoDetails, detailsArr[i]);
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyCOPPAActErrorMessage method verifies for the display of COPPAAct error message.
   * @param ErrorMsg 
   */
  async verifyCOPPAActErrorMessage(ErrorMsg){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getCOPPAActError(), true, timeout);    
    await globalMethods.verifyElement(await this.getCOPPAActError(), timeout, true);    
   // var actualErrorMsg = await accountSettings.getCOPPAActError().getText();
    var actualErrorMsg = await this.getCOPPAActError().getText().then(async function(text){
        return await text.toString().trim().toLowerCase();
    });
    await globalMethods.log("Error Message from App: "+ actualErrorMsg+"====>"+"Error Message from Data file: "+ErrorMsg);
    await globalMethods.verifyText(actualErrorMsg, ErrorMsg, true);
    await browser.waitForAngularEnabled(true);
  }
  // async verifyDemographicInfoCardElements(dataFile){
  //   await browser.waitForAngularEnabled(false);
  //   await globalMethods.waitForElement(await this.getDemographicInformationDetailsCard(), true, timeout);
  //   var DemographicInfoDetails = await this.getDemographicInformationDetailsCard().getText().then(async function(text){
  //       return await text.toString().trim().toLowerCase();
  //   });
  //   await globalMethods.log("Demographic Information details : ");
  //   await globalMethods.log(DemographicInfoDetails);
  //   await globalMethods.log("Demographic Information details from dataFile: ");
  //   let detailsArr: Array<string> = [dataFile.email, dataFile.dob, dataFile.gender, dataFile.primaryphone, dataFile.address];
  //   for(let i in detailsArr) {
  //       await globalMethods.log("========" + detailsArr[i] + "=============");
  //       await globalMethods.verifyTextContains(DemographicInfoDetails, detailsArr[i], true);
  //   }

  //   await browser.waitForAngularEnabled(true);
  // }
  /**
   * verifyNameAbsenceOnDemographicInformationCard method verifies that the name is not displayed in demographic information card.
   * @param name 
   */
  async verifyNameAbsenceOnDemographicInformationCard(name){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getDemographicInformationDetailsCard(), true, timeout);
    var DemographicInfoDetails = await this.getDemographicInformationDetailsCard().getText().then(async function(text){
        return await text.toString().trim().toLowerCase();
    });
    await globalMethods.log("Demographic Information details : ");
    await globalMethods.log(DemographicInfoDetails);
    await globalMethods.log("Demographic Information details from dataFile: "+ name);
    await globalMethods.verifyText(DemographicInfoDetails, name, false);  
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureClickAllEmailSettingsToggle method clicks on toggle of 'Toggle All Email Settings' section.
   * @param allEmailIsEnabled 
   */
  async procedureClickAllEmailSettingsToggle(allEmailIsEnabled){
    var ToggleAllEmailSettings = allEmailIsEnabled;
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getChangesMadeToYourAccountToggleState(),true,timeout);
    var isSelectedToggle = await this.getToggleAllEmailSettingsState().isSelected();
    console.log("isSelectedToggle=>" + isSelectedToggle);
    if (isSelectedToggle && !ToggleAllEmailSettings) {
        await this.clickToggleAllEmailSettingsSlider().then(function () {
            console.log('Toggle all email settings are now disabled');
        });
    } else {
        await this.clickToggleAllEmailSettingsSlider().then(function () {
            console.log('Toggle all email settings are now enabled');
        });
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyToggleAllEmailSettings method verifies if 'Toggle All Email Settings' are disabled.
   */
  async procedureVerifyToggleAllEmailSettings(){
    await browser.waitForAngularEnabled(false);
    var expectedValue = await this.getToggleAllEmailSettingsState().isSelected();
    //var actualValue = await dataFile.allEmailIsEnabled;
    await globalMethods.log(false + "=" + expectedValue);
    await globalMethods.verifyFailOnError(false, expectedValue,"Toggle All Email Settings Are Disabled", true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * procedureVerifyToggleAllEmailSettingsEnabled method verifies if 'Toggle All Email Settings' are enabled.
   */
  async procedureVerifyToggleAllEmailSettingsEnabled(){
    await browser.waitForAngularEnabled(false);
    var expectedValue = await this.getToggleAllEmailSettingsState().isSelected();   
    await globalMethods.log(true + "=" + expectedValue);
    await globalMethods.verifyFailOnError(true, expectedValue,"Toggle All Email Settings Are Enabled", true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickLegalNoticeCardHeader method clicks on Legal Notice Card header.
   * @param isExpanded 
   */
  async clickLegalNoticeCardHeader(isExpanded){
    await browser.waitForAngularEnabled(false);
    var legalNoticeCardIsExpanded = await this.getLegalNoticeHeaderCard().getAttribute('aria-expanded');
    if (legalNoticeCardIsExpanded && isExpanded) {
        await globalMethods.log("Legal Notice Card header is already expanded");
    } else {
        await this.getLegalNoticeHeaderCard().click();
        await globalMethods.log("Legal Notice Card header is now collapsed");
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyLinksOnAccountSettingsPage method verifies for copyright, privacy policy, Terms and Conditions, Language assistance, Non discrimination, international links on Account Settings page.
   */
  async verifyLinksOnAccountSettingsPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.verifyElement(await this.getCopyright(), timeout, true);
    await globalMethods.verifyElement(await this.getPrivacyPolicy(), timeout, true);
    await globalMethods.verifyElement(await this.getTermsAndConditions(), timeout, true);
    await globalMethods.verifyElement(await this.getLanguageAssistance(), timeout, true);
    await globalMethods.verifyElement(await this.getNondiscrimination(), timeout, true);
    await globalMethods.verifyElement(await this.getInternational(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyLinksAbsenceOnAccountSettingsPage method verfies for the absence of links on account settings page.
   * @param isExpanded 
   */
  async verifyLinksAbsenceOnAccountSettingsPage(isExpanded){
    await browser.waitForAngularEnabled(false);
    await this.getLegalNoticeHeaderCard().getAttribute('aria-expanded').then(async function (legalNoticeCardIsExpanded) {
        await globalMethods.log(isExpanded + "==" + legalNoticeCardIsExpanded);
        if (await legalNoticeCardIsExpanded === isExpanded) {
            await globalMethods.log("Legal Notice card is collapsed and now checking for equality");
            await globalMethods.verifyFailOnError(isExpanded, legalNoticeCardIsExpanded, "Verifying LegalNotice card is collapsed and links are not visible", true);
        }
    });
    await browser.waitForAngularEnabled(false);
  }
  /**
   * clickLinksOnLegalNoticeCard method clicks on links of Legal Notice Card section.
   * @param link 
   */
  async clickLinksOnLegalNoticeCard(link){
    await browser.waitForAngularEnabled(false);
    switch (link) {
        case 'copyright':
            await this.getCopyright().click();
            break;
        case 'privacyPolicy':
            await this.getPrivacyPolicy().click();
            break;
        case 'termsAndConditions':
            await this.getTermsAndConditions().click();
            break;
        case 'languageAssistance':
            await this.getLanguageAssistance().click();
            break;
        case 'assistencia':
            await this.getNondiscrimination().click();
            break;
        case 'international':
            await this.getInternational().click();
            break;

        default:
            break;
    }
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyLinksOnLegalNoticeCard method verifies if the respective link opens in new tab.
   * @param link 
   */
  async verifyLinksOnLegalNoticeCard(link){    
    await browser.waitForAngularEnabled(false);
    switch (link) {
        case 'copyright':
            await globalMethods.switchTabs(1).then(async function () {                
                var currentUrl = await browser.getCurrentUrl();
                await globalMethods.log("Copyright URL from Application: "+currentUrl);
                await globalMethods.verifyTextContains(currentUrl, copyrightText, true);
            });
            break;
        case 'privacyPolicy':
        await globalMethods.switchTabs(1).then(async function () {            
            //await globalMethods.goToURL(privacyPolicyUrl, await accountSettings.getLegalNoticeCardNewPageValidator());
            var currentUrl = await browser.getCurrentUrl();
            await globalMethods.log("Privacy Policy URL from Application: "+currentUrl);
            await globalMethods.verifyTextContains(currentUrl, privacypolicyText, true);
         });
         break;
        case 'termsAndConditions':
        await globalMethods.switchTabs(1).then(async function () {            
            //await globalMethods.goToURL(termsAndConditionsUrl, await accountSettings.getLegalNoticeCardNewPageValidator());
            var currentUrl = await browser.getCurrentUrl();
            await globalMethods.log("Terms And Conditions URL from Application: "+currentUrl);
            await globalMethods.verifyTextContains(currentUrl, termsAndConditionsText, true);

        });
        break;
        case 'languageAssistance':
        await globalMethods.switchTabs(1).then(async function () {            
           // await globalMethods.goToURL(nondiscriminationUrl, await accountSettings.getLegalNoticeCardNewPageValidator());
            var currentUrl = await browser.getCurrentUrl();
            await globalMethods.log("Language Assistance URL from Application: "+currentUrl);
            await globalMethods.verifyTextContains(currentUrl, languageAssistanceText, true);

        });
        break;
        case 'assistencia':
        await globalMethods.switchTabs(1).then(async function () {           
            //await globalMethods.goToURL(nondiscriminationUrl, await accountSettings.getLegalNoticeCardNewPageValidator());
            var currentUrl = await browser.getCurrentUrl();
            await globalMethods.log("Assistencia URL from Application:"+currentUrl);
            await globalMethods.verifyTextContains(currentUrl, assistenciaText, true);

        });
        break;
        case 'international':
        await globalMethods.switchTabs(1).then(async function () {            
            //await globalMethods.goToURL(nondiscriminationUrl, await accountSettings.getLegalNoticeCardNewPageValidator());
            var currentUrl = await browser.getCurrentUrl();
            await globalMethods.log("Internation URL from Application: "+currentUrl);
            await globalMethods.verifyTextContains(currentUrl, internationalText, true);

        });
        break;
        default:
            break;
    }
    var handles = await browser.driver.getAllWindowHandles()
    for (let i = 1; i < handles.length; i++) {
     if (handles[i]) {
      await globalMethods.log("Closing legal notice card links tab: " + i + " **");
      browser.driver.switchTo().window(handles[i]);
      await globalMethods.closeTab();
     }
    }     
    await globalMethods.switchTabs(0);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyDeviceOnManageDeviceAuthorizationsPage method verifies for the Device button of Manage Device authorization page.
   */
  async verifyDeviceOnManageDeviceAuthorizationsPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getDevice(), true, timeout);
    await globalMethods.verifyElement(await this.getDevice(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyRemoveDeviceOnManageDeviceAuthorizationsPage method verifies for 'Remove Device' button of Manage Device Authorization page.
   */
  async verifyRemoveDeviceOnManageDeviceAuthorizationsPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRemoveDevice(), true, timeout);
    await globalMethods.verifyElement(await this.getRemoveDevice(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * clickRemoveDeviceCancel method clicks on 'Cancel' button of Remove Device Popup.
   */
  async clickRemoveDeviceCancel(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRemoveDevice(), true, timeout);
    await globalMethods.click(await this.getRemoveDeviceCancel(), 'Cancel on Remove Device popup', timeout);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyRemoveDevicePopupOnManageDeviceAuthorizationPage method verifies for the display of Remove Device Popup On Manage Device Authorization Page.
   */
  async verifyRemoveDevicePopupOnManageDeviceAuthorizationPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRemoveDevicePopUpTitle(), true, timeout);
    await globalMethods.verifyElement(await this.getRemoveDevicePopUpTitle(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyRemoveOnRemoveDevicePopUp method verifies for 'Remove' button of Remove Device PopUp.
   */
  async verifyRemoveOnRemoveDevicePopUp(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRemove(), true, timeout);
    await globalMethods.verifyElement(await this.getRemove(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyCancelOnRemoveDevicePopUp method verifies for 'Cancel' button of Remove Device PopUp.
   */
  async verifyCancelOnRemoveDevicePopUp(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getRemoveDeviceCancel(), true, timeout);
    await globalMethods.verifyElement(await this.getRemoveDeviceCancel(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyLearnMoreOnAccountSettingsPage method verifies for the presence of Learn More link on Account Settings page
   */
  async verifyLearnMoreOnAccountSettingsPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getLearnMore(), true, timeout);
    await globalMethods.verifyElement(await this.getLearnMore(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyCreateDirectAddressCard method verifies for the presence of Create Direct Address Card of Account Settings Page.
   */
  async verifyCreateDirectAddressCard(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getCreateDirectAddressCard(), true, timeout);
    await globalMethods.verifyElement(await this.getCreateDirectAddressCard(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyMessageOnCreateDirectAddressCard method verifies for the presence of message on Create Direct Address Card
   */
  async verifyMessageOnCreateDirectAddressCard(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getMessageOnreateDirectAddressCard(), true, timeout);
    await globalMethods.verifyElement(await this.getMessageOnreateDirectAddressCard(), timeout, true);
    await globalMethods.waitForElement(await this.getLearnMore(), true, timeout);
    await globalMethods.verifyElement(await this.getLearnMore(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyDirectEmailAddress method verifies for the presence of Direct Email Address on Account Settings page. 
   */
  async verifyDirectEmailAddress(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getDirectEmailAddress(), true, timeout);
    await globalMethods.verifyElement(await this.getDirectEmailAddress(), timeout, true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyLearnMoreNotvisibleOnAccountSettingsPage method verifies for the absence of Learn more on Account Settings page.
   */
  async verifyLearnMoreNotvisibleOnAccountSettingsPage(){
    await browser.waitForAngularEnabled(false);
    var LearnMoreActualvalue = await this.getLearnMore().isPresent();
    await globalMethods.log('Learn More Actual value:'+LearnMoreActualvalue);
    globalMethods.verifyFailOnError(LearnMoreActualvalue, false, "Learn More",true);
    await browser.waitForAngularEnabled(true);
  }
  /**
   * verifyCloseOnAccountSettingsPage method verifies for the presence of close on account settings page.
   */
  async verifyCloseOnAccountSettingsPage(){
    await browser.waitForAngularEnabled(false);
    await globalMethods.waitForElement(await this.getClose(), true, timeout);
    await globalMethods.verifyElement(await this.getClose(), timeout, true); 
    await browser.waitForAngularEnabled(true);
  }

  /**
   * verifyMessageOnDemographicsPanel method verifies for the message displayed on Demographics panel of Account Settings page.
   * @param dataFile 
   */
  async verifyMessageOnDemographicsPanel(dataFile){    
    await browser.waitForAngularEnabled(false);
    let actualMsg = await this.getContactFormInfo().getText().then(async function(text){
        return await text.toString().trim().toLowerCase();
    });
    await globalMethods.log("Message from app =>"+ actualMsg);
    var expectedDemographicChangeMsg = await dataFile.demographicChangeMsg;
    await globalMethods.verifyText(await actualMsg, expectedDemographicChangeMsg, true );
  }
}