import { Then, When, Given } from 'cucumber';
import { appendFile } from 'fs';
import { browser } from 'protractor';
import * as globalMethods from 'quest-global';
import { Common } from '../support/common';
import { ApiAutomated } from '../api/apiAutomated';
import { DbConnect } from '../api/dbConnect';
import { data } from 'jquery';
import * as hrspayloadjson from '../../jsonfiles/hrspayload.json';
//import { assert } from 'console';

let axios = require('axios');
var chai = require('chai');
var assert = chai.assert;
let global = require('../global/global');``
let dbConnect = new DbConnect();
let apiAutomated = new ApiAutomated();
let json1;
let json2;
var result;
var finalresult;
const path1 = './jsonfiles/quest-data.xlsx';
const path2 = './jsonfiles/hrs_db.xlsx';

//Compare two excel files of HRS and Lab
Given('I have two excels questdata and hrsdb coverted to jsons', async()=> {
         json1 = await apiAutomated.getExceltoJson(path1);
         json2 = await apiAutomated.getExceltoJson(path2);
})
When('I compare two jsons', async()=> {
        apiAutomated.diff(json1,json2);
        result = await apiAutomated.diff(json1,json2);
})
Then('I get response pass if they are equal or print difference if two excels are not equal', async()=> {
        finalresult= await apiAutomated.hasDiffsCompareTwoExcel(result);
        assert.isFalse(finalresult, "Both excels are not equal");
})
