
# Feature Description: This feature file has all APIs related to Health Integration Service

Feature: Verify Health Integration APIs 

    @P1 @uiAutoReady @HIS
    Scenario: Returns PWN order approval status, timestamp and message type / category with specified pwnRequisitionId
    Given HIS API request in qa environment
    When I do GET request to /geneticreview
    Then I get response with approvalStatus approved

    @P1 @uiAutoReady @HIS
    Scenario: Returns PWN order approval status, timestamp and message type / category with specified parentId
    Given HIS API request in qa environment
    When I do GET request to /geneticreviewpid
    Then I get response with approvalStatus approved pid

    @P1 @uiAutoReady @HIS
    Scenario: Verify entire health-history using parent-test-guid
    Given HIS API request in qa environment
    When I do GET for health-history request for parent-test-guid
    Then I get response data for parent-test-guid

    @P1 @uiAutoReady @HIS
    Scenario: Verify healthhistory for specific parent test guid which is filter by disease category
    Given HIS API request in qa environment
    When I do GET for health-history request for disease category
    Then I get response data for disease category
    
    @P1 @uiAutoReady @HIS
    Scenario: Verify healthhistory for specific parent test guid which is filter by question key
    Given HIS API request in qa environment
    When I do GET for health-history request filter by question key 
    Then I get response data filter by question key 
    
    @P1 @uiAutoReady @HIS
    Scenario: Verify request with multiple question keys
    Given HIS API request in qa environment
    When I do GET for health-history request for multiple question keys
    Then I get response data for multiple question keys
    
    @P3 @uiAutoReady @HIS
    Scenario: Verify the status for Health Integration service
    Given HIS API request in qa environment
    When I do GET request to /status
    Then I get response code 200

    @P3 @uiAutoReady @HIS
    Scenario: Verify health of the Service for Health Integration service
    Given HIS API request in qa environment
    When I do GET for healthcheck request 
    Then I get response data